/*
 * $Id: InsertCitationReferenceDialog.C,v 1.7 1998/08/11 15:11:01 kuepper Exp $
 */

#include "InsertCitationReferenceDialog.h"
#include "insetbib.h"
#include "LyXView.h"

#include <qcombo.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlined.h>
#include <qpushbt.h>

#include <kapp.h>
#include <kbuttonbox.h>
#include <klocale.h>


extern void UpdateInset(Inset* inset, bool mark_dirty = true);


InsertCitationReferenceDialog::InsertCitationReferenceDialog( LyXView* view, QWidget * parent=0, 
							      const char * name=0, WFlags f=0 )
    : QDialog( parent, name, true, f ),
      _view( view )
{
    setCaption( i18n( "Insert Citation" ) );
    QGridLayout *layout = new QGridLayout( this, 3, 2, 10 );
  
    QLabel* keyLA = new QLabel( i18n( "&Key:" ), this );
    keyLA->setAlignment( AlignVCenter | AlignRight );
    keyLA->setMinimumSize( keyLA->sizeHint() );
    layout->addWidget( keyLA, 0, 0, AlignRight );
    keyCB = new QComboBox( true, this );
    keyCB->setFixedHeight( keyCB->sizeHint().height() );
    keyCB->setMinimumWidth( keyCB->sizeHint().width() );
    layout->addWidget(keyCB, 0, 1);
    keyLA->setBuddy( keyCB );

    QLabel* remarkLA = new QLabel( i18n( "&Remark:" ), this );
    remarkLA->setAlignment( AlignVCenter | AlignRight );
    remarkLA->setMinimumSize( remarkLA->sizeHint() );
    layout->addWidget( remarkLA, 1, 0, AlignRight );
    remarkED = new QLineEdit( this );
    remarkED->adjustSize();
    remarkED->setFixedHeight( remarkED->sizeHint().height() );
    remarkED->setMinimumWidth( remarkED->sizeHint().width() );
    layout->addWidget( remarkED, 1, 1 );
    remarkLA->setBuddy( remarkED );

    KButtonBox *bbox = new KButtonBox( this );
    bbox->addStretch( 1 );
    QPushButton* okPB = bbox->addButton( i18n( "OK" ) );
    okPB->setMinimumSize( okPB->sizeHint() );
    okPB->setDefault( true );
    connect( okPB, SIGNAL( clicked() ), SLOT( okClicked() ) );
    bbox->addStretch( 1 );
    QPushButton* cancelPB = bbox->addButton( i18n( "Cancel" ) );
    cancelPB->setMinimumSize( cancelPB->sizeHint() );
    connect( cancelPB, SIGNAL( clicked() ), SLOT( reject() ) );
    bbox->addStretch( 1 );
    bbox->layout();
    layout->addMultiCellWidget( bbox, 2, 2, 0, 1 );

    layout->activate();
    resize( sizeHint() );
}


void InsertCitationReferenceDialog::okClicked()
{
    if( !_view->currentBuffer()->isReadonly() ) {
	inset->setContents( keyCB->currentText() );
	inset->setOptions( remarkED->text() );
	// shouldn't mark the buffer dirty unless something
	// was actually altered
	UpdateInset(inset);
    }
	
    accept();
}


void InsertCitationReferenceDialog::ensureBibItem( const char* item )
{
    bool found = false;
    for( int i = 0; i < keyCB->count(); i++ )
	if( !strcmp( keyCB->text( i ), item ) )
	{
	    keyCB->setCurrentItem( i );
	    found = true;
	    break;
	}
    if( !found )
	keyCB->insertItem( item );
    return;
}


void InsertCitationReferenceDialog::updateBibItems()
{
    keyCB->clear();
    if (!_view->currentView()->available())
	return;
    LyXParagraph *par = _view->currentBuffer()->paragraph;    
    while( par ) {
	if( par->bibkey )
	    keyCB->insertItem( par->bibkey->getContents().c_str() );
	par = par->next;
    }
    return;
}
